//+------------------------------------------------------------------+
//|                                                 BAR BREAKOUT.mq4 |
//|                                                         alexey15 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


//+--------------------------------------------------------------+
//---- input parameters                                          !
//+--------------------------------------------------------------+

extern int DELTA = 1;      //      
extern double LOT = 0.1;   // .
extern double MULT = 3;   //   , ..   ()    
extern int XBARS = 1; //        -   -  !!! :-)))
//------------------
// MOVING AVERAGE
//------------

extern int MAPERIOD       = 3;
extern int MASHIFT        = 3;

//---------------------------------------------------------------



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+--------------------------------------------------------------------  
// WAIT FOR A NEW BAR 
//+------------------------------------------------------------

bool NewBar(){  
   static datetime lastbar = 0; 
   datetime curbar = Time[0]; 
   if(lastbar!=curbar){ 
      lastbar=curbar; 
      return(true); 
   }else
   { 
      return(false); 
   } 
  

   }


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 
//----------------------------------------------
// CHECK IF THERE IS A NEW BAR 
//---------------------------------

  if (NewBar() == true)
   {

//-------------------------------------


double     SL; 		//  
double     TP;		//  
double     B_StopLoss;		//    
double     B_TakeProfit;		//    
double     S_StopLoss;		//    
double     S_TakeProfit;		//    
double SPREAD=(MarketInfo(Symbol(),MODE_SPREAD))*Point; 
int     OPEN_ORDER;         //  
datetime XPIR = CurTime()+XBARS*Period()*60;
//--------------------------------------------------------
//----------------

double MA;

//-------------
// GET MA
//--------

MA=iMA(NULL,0,MAPERIOD,MASHIFT,MODE_SMA,PRICE_CLOSE,0);

//-----------------------------------------------------------


double H=NormalizeDouble(iHigh(NULL,0,1)+DELTA*Point+SPREAD,Digits);   //    
double L=NormalizeDouble(iLow(NULL,0,1)-DELTA*Point,Digits);    //    


      SL=(H-L);	//  
      TP=MULT*SL; // 
          
            B_StopLoss=NormalizeDouble(H-SL,Digits);
            B_TakeProfit=NormalizeDouble(H+TP,Digits);
            S_StopLoss=NormalizeDouble(L+SL,Digits);
            S_TakeProfit=NormalizeDouble(L-TP,Digits);            

//---------------
// BUY ORDER 
//----------------
if ( iOpen(NULL,0,0)>=MA )
{
if(H-Ask>MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)    //     

OPEN_ORDER=OrderSend(Symbol(),OP_BUYSTOP,LOT,H,3,B_StopLoss,B_TakeProfit,NULL,0,XPIR,Blue);

   else           //    ,         

OPEN_ORDER=OrderSend(Symbol(),OP_BUYSTOP,LOT,Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,3,B_StopLoss,B_TakeProfit,NULL,0,XPIR,Blue);
}

//---------------------------------
// SELL ORDER 
//---------------------
if ( iOpen(NULL,0,0)<MA )
{   
if(Bid-L>MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)       

OPEN_ORDER=OrderSend(Symbol(),OP_SELLSTOP,LOT,L,3,S_StopLoss,S_TakeProfit,NULL,0,XPIR,Red);         

   else             

OPEN_ORDER=OrderSend(Symbol(),OP_SELLSTOP,LOT,Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,3,S_StopLoss,S_TakeProfit,NULL,0,XPIR,Red);         
}

//-------------------------


     return(0);


   } // NEWBAR
   } // START 











//+------------------------------------------------------------------+